//  **********************************************************************
//  MyMacro: General-purpose Macro definition
//  Last Updated: 980827
//  -   980907
//      SetSndOn, IsSndOn
//  -   980827
//      g_nLang: language flag
//  **********************************************************************
unit MyMacro;

interface
uses
    WinProcs, SysUtils;
var
    g_nLang: integer;
const
    // Sound Option
    LANG_ENGLISH: integer=0;	    // Lang English
    LANG_DOMESTIC: integer=1;	// Lang Domestic
    // Sound Option
    SND_OPT_NONE=0;	// with no sound effect
    SND_OPT_SOUND=1;	// with sound effect, no voice
    SND_OPT_VOICE=2;	// with sound effect, and voice
    // Boolean op flag
    BOP_AND : byte =0;
    BOP_OR  : byte =1;
    BOP_XOR : byte =2;
    // ***************************
    // Key char definition
    // ***************************
    C_NULL: char = Chr(0);
    C_SOH: char = Chr(1);
    C_STX: char = Chr(2);
    C_ETX: char = Chr(3);
    C_EOT: char = Chr(4);
    C_ENQ: char = Chr(5);
    C_ACK: char = Chr(6);  // for RS232 comm
    C_BEEP: char = Chr(7);
    C_BKSPACE: char = Chr(8);
    C_TAB: char = Chr(9);

    C_LINEFEED: char = Chr(10);  // Line Feed 
    C_VT: char = Chr(11);  // Line Feed
    C_TURNPG: char = Chr(12);  // Printer Turn Page 
    C_ENTER: char = Chr(13);  // Enter Key/Carriage Return 
    C_SO: char = Chr(14);
    C_SI: char = Chr(15);
    C_DLE: char = Chr(16); // Data Link Escape 
    C_DC1: char = Chr(17);  // DC1~DC2 for RS232 Client-Server msg
    C_XON: char = Chr(17);  // flow control: XON recv inbuf empty ask sender to send
    C_DC2: char = Chr(18);
    C_DC3: char = Chr(19);
    C_XOFF: char = Chr(19);  // flow control: XOFF recv tell sender stop to send

    C_DC4: char = Chr(20);
    C_NAK: char = Chr(21);
    C_SYN: char = Chr(22);
    C_ETB: char = Chr(23);
    C_CAN: char = Chr(24);
    C_EM: char = Chr(25);
    C_SUB: char = Chr(26);
    C_ESC: char = Chr(27);
    C_FS: char = Chr(28);
    C_GS: char = Chr(29);

    C_RS: char = Chr(30);
    C_US: char = Chr(31);
    C_SPACE: char = Chr(32);
    // *****************************************
    // Virtual Key Code redefine - Standard Set
    // *****************************************
    KEY_LBUTTON :Word=VK_LBUTTON;   // Mouse L-Button
    KEY_RBUTTON :Word=VK_RBUTTON;   // Mouse R-Button
    KEY_MBUTTON :Word=VK_MBUTTON;   // Mouse M-Button
    KEY_CANCEL  :Word=VK_CANCEL;    // ???

    KEY_BACK    :Word=VK_BACK;      // ???
    KEY_TAB     :Word=VK_TAB;

    KEY_CLEAR   :Word=VK_CLEAR;     // ???
    KEY_ENTER   :Word=VK_RETURN;

    KEY_SHIFT   :Word=VK_SHIFT;
    KEY_CTRL    :Word=VK_CONTROL;
    KEY_MENU    :Word=VK_MENU;
    KEY_PAUSE   :Word=VK_PAUSE;     // ???
    KEY_CAP     :Word=VK_CAPITAL;

    KEY_ESC     :Word=VK_ESCAPE;
    KEY_SPACE   :Word=VK_SPACE;
    KEY_PGUP    :Word=VK_PRIOR;     // ???
    KEY_PGDN    :Word=VK_NEXT;      // ???
    KEY_END     :Word=VK_END;
    KEY_HOME    :Word=VK_HOME;
    KEY_LF      :Word=VK_LEFT;
    KEY_UP      :Word=VK_UP;
    KEY_RT      :Word=VK_RIGHT;
    KEY_DN      :Word=VK_DOWN;
    KEY_SELECT  :Word=VK_SELECT;    // ???
    KEY_PRINT   :Word=VK_PRINT;     // ???
    KEY_EXEC    :Word=VK_EXECUTE;   // ???
    KEY_SNAPSHOT:Word=VK_SNAPSHOT;  // ???
    KEY_INS     :Word=VK_INSERT;
    KEY_DEL     :Word=VK_DELETE;
    KEY_HELP    :Word=VK_HELP;      // ???

    // VK_0 thru VK_9 are the same as ASCII '0' thru '9' (0x30 - 0x39)
    // VK_A thru VK_Z are the same as ASCII 'A' thru 'Z' (0x41 - 0x5A)


    KEY_NUM0    :Word=VK_NUMPAD0;
    KEY_NUM1    :Word=VK_NUMPAD1;
    KEY_NUM2    :Word=VK_NUMPAD2;
    KEY_NUM3    :Word=VK_NUMPAD3;
    KEY_NUM4    :Word=VK_NUMPAD4;
    KEY_NUM5    :Word=VK_NUMPAD5;
    KEY_NUM6    :Word=VK_NUMPAD6;
    KEY_NUM7    :Word=VK_NUMPAD7;
    KEY_NUM8    :Word=VK_NUMPAD8;
    KEY_NUM9    :Word=VK_NUMPAD9;
    KEY_ADD     :Word=VK_ADD;
    KEY_SUB     :Word=VK_SUBTRACT;
    KEY_MUL     :Word=VK_MULTIPLY;
    KEY_DIV     :Word=VK_DIVIDE;
    KEY_SEPERATOR:Word=VK_SEPARATOR; // ???
    KEY_DECIMAL :Word=VK_DECIMAL;
    KEY_F1      :Word=VK_F1;
    KEY_F2      :Word=VK_F2;
    KEY_F3      :Word=VK_F3;
    KEY_F4      :Word=VK_F4;
    KEY_F5      :Word=VK_F5;
    KEY_F6      :Word=VK_F6;
    KEY_F7      :Word=VK_F7;
    KEY_F8      :Word=VK_F8;
    KEY_F9      :Word=VK_F9;
    KEY_F10     :Word=VK_F10;
    KEY_F11     :Word=VK_F11;
    KEY_F12     :Word=VK_F12;

    KEY_NUMLOCK:Word=VK_NUMLOCK;
    KEY_SCROLLLOCK:Word=VK_SCROLL;

    // VK_L* & VK_R* - left and right Alt, Ctrl and Shift virtual keys.
    // Used only as parameters to GetAsyncKeyState() and GetKeyState().
    // No other API or message will distinguish left and right keys in this way.
    //
    KEY_LSHIFT  :Word=VK_LSHIFT;
    KEY_RSHIFT  :Word=VK_RSHIFT;
    KEY_LCTRL   :Word=VK_LCONTROL;
    KEY_RCTRL   :Word=VK_RCONTROL;
    KEY_LMENU   :Word=VK_LMENU; // ???
    KEY_RMENU   :Word=VK_RMENU; // ???
    KEY_LWIN    :Word=VK_LWIN;  // ???
    KEY_RWIN    :Word=VK_RWIN;  // ???
    KEY_APPS    :Word=VK_APPS;  // ???
    {
    #if(WINVER >= 0x0400)
    KEY_:Word=VK_PROCESSKEY     0xE5
    #endif /* WINVER >= 0x0400 */
    KEY_:Word=VK_ATTN           0xF6
    KEY_:Word=VK_CRSEL          0xF7
    KEY_:Word=VK_EXSEL          0xF8
    KEY_:Word=VK_EREOF          0xF9
    KEY_:Word=VK_PLAY           0xFA
    KEY_:Word=VK_ZOOM           0xFB
    KEY_:Word=VK_NONAME         0xFC
    KEY_:Word=VK_PA1            0xFD
    KEY_:Word=VK_OEM_CLEAR      0xFE
    }
procedure SetSndOn(bSndOn: boolean);
function IsSndOn: boolean;
implementation
var
    s_bSndOn: boolean;
//  ------------------------------------------------------------------------
//@ IsSndOn/SetSndOn
//  Get/Set TBmpAni Sound Option
//  -   bSndOn
//      TRUE:   Play OnMouseMove HighLight Sound
//      FALSE:  OnMouseMove No play sound
//  ------------------------------------------------------------------------
procedure SetSndOn(bSndOn: boolean);
begin // [
    s_bSndOn:=bSndOn;
end; // ] SetSndOn
function IsSndOn: boolean;
begin // [
    Result:=s_bSndOn;
end; // ] IsSndOn

initialization
    s_bSndOn:=TRUE;
    g_nLang:=LANG_ENGLISH;
end.
